void getWords(String word, int beginDate, int endDate, int wordIndex) {

  try {
    String request = "";
    request += baseURL; 
    request += "?q=" + word;
    request += "&begin_date=" + beginDate;
    request += "&end_date=" + endDate;
    request += "&fl=lead_paragraph,word_count,pub_date"; 
    request += "&fq=subject:(\"music\")";   // filter
    request += "&api-key=" + apiKey; 

    JSONObject root = loadJSONObject(request);
    JSONObject response = root.getJSONObject("response"); // response includes meta (time, hits, offset)
    JSONArray docs = response.getJSONArray("docs");

    JSONObject meta = response.getJSONObject("meta");
    numHits = meta.getInt("hits");  // number of hits per time period

    for (int i=0; i<numParagraphs; i++) {
      JSONObject lead_paragraph = docs.getJSONObject(i);
      paragraph[i] = lead_paragraph.getString("lead_paragraph");
      JSONObject docsPlus1 = docs.getJSONObject(i);
      wCount = docsPlus1.getInt("word_count");

      contentTargetList[wordIndex].append(paragraph[i]);
      contentTarget.append(paragraph[i]);
      wordCountTargetList[wordIndex].append(wCount);
      wordCountTarget.append(wCount);
      pubYearTarget.append((int)(beginDate/10000));
      docTarget.append(docsPlus1);
      println(docsPlus1);
    }
  }
  catch (Exception e) {
    e.printStackTrace();
  }
}

void loadData() {
  pop_docs = loadJSONArray("pop_docs.json");
  pop_hits = loadJSONArray("pop_num_hits.json");
  rock_docs = loadJSONArray("rock_docs.json");
  rock_hits = loadJSONArray("rock_num_hits.json");
  country_docs = loadJSONArray("country_docs.json");
  country_hits = loadJSONArray("country_num_hits.json");
  hiphop_docs = loadJSONArray("hiphop_docs.json");
  hiphop_hits = loadJSONArray("hiphop_num_hits.json");
  techno_docs = loadJSONArray("techno_docs.json");
  techno_hits = loadJSONArray("techno_num_hits.json");
  electronic_docs = loadJSONArray("electronic_docs.json");
  electronic_hits = loadJSONArray("electronic_num_hits.json");
  jazz_docs = loadJSONArray("jazz_docs.json");
  jazz_hits = loadJSONArray("jazz_num_hits.json");
  classical_docs = loadJSONArray("classical_docs.json");
  classical_hits = loadJSONArray("classical_num_hits.json");
  experimental_docs = loadJSONArray("experimental_docs.json");
  experimental_hits = loadJSONArray("experimental_num_hits.json");

  numObjects = pop_docs.size(); 
  numObjects += rock_docs.size(); 
  numObjects += country_docs.size(); 
  numObjects += hiphop_docs.size();
  numObjects += techno_docs.size();
  numObjects += electronic_docs.size();
  numObjects += jazz_docs.size();
  numObjects += classical_docs.size();
  numObjects += experimental_docs.size();
  //  println("numObjects: " + numObjects);
  itemList[0] = pop_docs.size(); 
  itemList[1] = rock_docs.size(); 
  itemList[2] = country_docs.size(); 
  itemList[3] = hiphop_docs.size();
  itemList[4] = techno_docs.size();
  itemList[5] = electronic_docs.size();
  itemList[6] = jazz_docs.size();
  itemList[7] = classical_docs.size();
  itemList[8] = experimental_docs.size();

  popLowerLim = 0;
  popUpperLim = itemList[0];
  rockLowerLim = itemList[0]; 
  rockUpperLim = itemList[0]+itemList[1];
  countryLowerLim = itemList[0]+itemList[1]; 
  countryUpperLim = itemList[0]+itemList[1]+itemList[2];
  hiphopLowerLim = itemList[0]+itemList[1]+itemList[2]; 
  hiphopUpperLim = itemList[0]+itemList[1]+itemList[2]+itemList[3];
  technoLowerLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]; 
  technoUpperLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4];
  electronicLowerLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]; 
  electronicUpperLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5];
  jazzLowerLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5]; 
  jazzUpperLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5]+itemList[6];
  classicalLowerLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5]+itemList[6]; 
  classicalUpperLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5]+itemList[6]+itemList[7];
  experimentalLowerLim = itemList[0]+itemList[1]+itemList[2]+itemList[3]+itemList[4]+itemList[5]+itemList[6]+itemList[7]; 
  experimentalUpperLim = numObjects;
}

