void drawGUI() {
  currentCameraMatrix = new PMatrix3D(g3.camera);
  camera();
  cP5.draw();
  g3.camera = currentCameraMatrix;

  colorMode(RGB);
  fill(fontColor);
  textFont(myFutura40); 
  textAlign(LEFT, CENTER);
  if (labelFlag == true) {
    text("Music Journalism Timeline", p5Margin, p5Margin*2);
    textFont(myFutura16); 
    text("A collection of New York Times articles about music, \nstructured by genre", p5Margin, p5Margin*5);
//    text("Total hits per year", p5LeftMargin, p5TopMargin+p5Distance*24+5);
  }

  textFont(myFutura12);
  text("enter word to search for", p5LeftMargin+30, p5TopMargin-30);
  text("universal word gravity", p5LeftMargin+30, p5TopMargin+p5Distance*1+5);
  text("order by category", p5LeftMargin+30, p5TopMargin+p5Distance*2+5);
  text("order by word count", p5LeftMargin+30, p5TopMargin+p5Distance*3+5);
  text("order by date", p5LeftMargin+30, p5TopMargin+p5Distance*4+5);
  text("labels", p5LeftMargin+30, p5TopMargin+p5Distance*5+5);

  text("range", p5LeftMargin+135, p5TopMargin+p5Distance*8+5);
  text("speed", p5LeftMargin+135, p5TopMargin+p5Distance*9+5);
  text("zoom", p5LeftMargin+135, p5TopMargin+p5Distance*10+5);
  text("x slide", p5LeftMargin+135, p5TopMargin+p5Distance*11+5);
  text("rotation", p5LeftMargin+30, p5TopMargin+p5Distance*12+5);

  text("audio", p5LeftMargin+30, p5TopMargin+p5Distance*13+5);
  text(words[0], p5LeftMargin+30, p5TopMargin+p5Distance*15+5);
  text(words[1], p5LeftMargin+30, p5TopMargin+p5Distance*16+5);
  text(words[2], p5LeftMargin+30, p5TopMargin+p5Distance*17+5);
  text(words[3], p5LeftMargin+30, p5TopMargin+p5Distance*18+5);
  text(words[4], p5LeftMargin+30, p5TopMargin+p5Distance*19+5);
  text(words[5], p5LeftMargin+30, p5TopMargin+p5Distance*20+5);
  text(words[6], p5LeftMargin+30, p5TopMargin+p5Distance*21+5);
  text(words[7], p5LeftMargin+30, p5TopMargin+p5Distance*22+5);
  text(words[8], p5LeftMargin+30, p5TopMargin+p5Distance*23+5);

  fill(fontColor);
}

void setupGUI() {
  cP5 = new ControlP5(this);
  cP5.setFont(myFutura12);
  cP5.setColorLabel(255);  
  p5LeftMargin = (width-(buttonWidth+60));
  p5TopMargin = 120;

  cP5.addTextfield("input")
    .setPosition(p5LeftMargin, p5TopMargin - 20)
      .setSize(buttonWidth, 30)
        .setFont(myFutura18)
          .setFocus(true)
            .setColor(color(255, 255, 255))
              .setLabel("");
  ;
  // toggle gravity
  cP5.addToggle("gravityFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*1)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(false)
            ;
  // toggle labels
  cP5.addToggle("categoryFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*2)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(false)
            ;
  // toggle wordCountFlag
  cP5.addToggle("wordCountFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*3)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(false)
            ;
  // toggle pubDateFlag
  cP5.addToggle("pubDateFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*4)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(false)
            ;
  // toggle labelFlag
  cP5.addToggle("labelFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*5)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // end/begin slider
  range = cP5.addRange("range")
    .setBroadcast(false)
      .setPosition(p5LeftMargin, p5TopMargin+p5Distance*8)
        .setSize(buttonWidth-40, buttonHeight)
          .setHandleSize(6)
            .setRange(0, 69)
              .setBroadcast(true)
                .setHighValue(12)
                  .setLabel("")
                    ;
  // zoom of small window
  cP5.addSlider("Time")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*9)
      .setSize(buttonWidth-40, buttonHeight)
        .setRange(0, 10)
          .setValue(3)
            .setLabel("")
              ;
  // zoom of small window
  cP5.addSlider("ZOOM")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*10)
      .setSize(buttonWidth-40, buttonHeight)
        .setRange(0, 2)
          .setValue(1)
            .setLabel("")
              ;
  // slide along x-axis
  cP5.addSlider("x_orientation")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*11)
      .setSize(buttonWidth-40, buttonHeight)
        .setRange(-3, 1)
          .setValue(-0.3)
            .setLabel("")
              ;
  // toggle rotation
  cP5.addToggle("rotationFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*12)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // reset rotation
  //  cP5.addButton("rotationReset")
  //    .setPosition(p5LeftMargin + int(buttonWidth/2)+4, p5TopMargin+p5Distance*12)
  //      .setSize((int(buttonWidth/2))-4, buttonHeight)
  //        //  .setColorBackground(color(#000000))
  //        //  .setColorForeground(color(#868686))
  //        // .setColorActive(color(#FFFFFF))
  //        .setLabel("")
  //          ;
  // toggle audio
  cP5.addToggle("audioFlag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*13)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category1
  cP5.addToggle("category1Flag")
    .setPosition(p5LeftMargin+p5Distance*0, p5TopMargin+p5Distance*15)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category2
  cP5.addToggle("category2Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*16)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category3
  cP5.addToggle("category3Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*17)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category4
  cP5.addToggle("category4Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*18)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category5
  cP5.addToggle("category5Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*19)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category6
  cP5.addToggle("category6Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*20)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category7
  cP5.addToggle("category7Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*21)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category8
  cP5.addToggle("category8Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*22)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;
  // toggle category9
  cP5.addToggle("category9Flag")
    .setPosition(p5LeftMargin, p5TopMargin+p5Distance*23)
      .setSize(buttonHeight, buttonHeight)
        //  .setColorBackground(color(#000000))
        //  .setColorForeground(color(#868686))
        // .setColorActive(color(#FFFFFF))
        .setLabel("")
          .setValue(true)
            ;

  cP5.setAutoDraw(false);
}

void controlEvent(ControlEvent theEvent) {
  if (theEvent.isController()) {
    if (theEvent.controller().name()=="ZOOM") {
      subZoom = theEvent.controller().value() ;
    }
    if (theEvent.controller().name()=="Time") {
      time = theEvent.controller().value() ;
    }
    if (theEvent.controller().name()=="range") {
      begin = int(theEvent.getController().getArrayValue(0));
      end = constrain(int(theEvent.getController().getArrayValue(1)), 2, 69);
    }
    if (theEvent.controller().name()=="x_orientation") {
      x_slide = theEvent.controller().value() ;
    }
    if (theEvent.isAssignableFrom(Textfield.class)) {
      queryString = theEvent.getStringValue(); 
      target = 1;
      queryFlag = true;  
      println("controlEvent: accessing a string from controller '"
        +theEvent.getName()+"': "
        +theEvent.getStringValue()
        );
    }
    print("control event from : "+theEvent.controller().name());
    println(", value : "+theEvent.controller().value());
  }
}

