class DataObject {

  int index; 
  int category;
  int wordCount; 
  int pubDate; 
  int matchFactor; 
  float opacity; 
  String content; 
  String query; 
  String[] contentArray; 
  int categorySize; 
  PVector currentPosition;
  PVector velocity; 
  DataObject[] others;

  float counter;
  int dateTrigger = 0; 
  int sizeScale = 100;
  float categoryColor;
  float circleMap;

  DataObject(
  int _index, 
  int _category, 
  int _categorySize, 
  int _wordCount, 
  int _pubDate, 
  String _content, 
  PVector _currentPosition, 
  PVector _velocity, 
  DataObject[] _others) {
    index = _index;
    category = _category;
    categorySize = _categorySize;
    wordCount = _wordCount; 
    pubDate = _pubDate; 
    content = _content;
    currentPosition = _currentPosition;
    velocity = _velocity; 
    others = _others;
    opacity = 64; 
  }
  //
  void display() {
    colorMode(HSB);
    categoryColor = map(category, 0, 8, 0, 218);
    strokeWeight(0.75);
    fill(categoryColor, 128, 255, opacity);
    stroke(255, dateTrigger);
    circleMap = map(index, 0, categorySize, 0, 2*PI);
    translate(sin(circleMap)*currentPosition.x, currentPosition.y, cos(circleMap)*currentPosition.x);
    box(wordCount/sizeScale*1.0);
    colorMode(RGB);
    fill(255);
    //text(category, 0, 0);
    //println("agent " + index + " display check\n");
  }

  void move() {
    currentPosition.add(velocity);
  }

  void findQueryMatch() {
    matchFactor = 0;
    counter = 0;
    String delimiters = ",.?!;:[]- ";
    String contentLowerCase = content.toLowerCase();
    String queryLowerCase = query.toLowerCase();
    contentArray = splitTokens(contentLowerCase, delimiters);
    for (int k=0; k<contentArray.length; k++) {
      if (contentArray[k].equals(queryLowerCase)) {
        matchFactor++;
      }
    }
    if (matchFactor > 0) {
      println("found " + query + " " + matchFactor + " times in agent " + index);
    }
  }
}

