//Music Journalism Timeline
//by Matthias Wagner, March 2015, for MAT 259 A
//This program takes data from the New York Times API and visualizes and sonifies it. 
//The data is queried separately, and then stored in .json files in the data folder, 
//from which the program reads.

import peasy.test.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;
import controlP5.*;
import ddf.minim.*; 
import ddf.minim.ugens.*;

PeasyCam cam; 
ControlP5 cP5;

PMatrix3D currentCameraMatrix;
PGraphics3D g3;

Minim minim;
AudioOutput out;

// data variables --------------------------------------------------------------------------------------
String apiKey = "e70c00999ff4d1b35722c543e0a284b6:4:71463327"; 
String baseURL = "http://api.nytimes.com/svc/search/v2/articlesearch.json";
String words[] = {
  "pop", "rock", "country", "hip-hop", "techno", "electronic", "jazz", "classical", "experimental"
};

int numObjects = 2094; 
int numYears = 70;
int numWords = 9;
int numParagraphs = 20;

int firstBeginDate = 19450101; 
int firstEndDate = 19451231; 

int[] beginDate = new int[numYears];
int[] endDate = new int[numYears];
int numHits;
int wCount;
int[] hits = new int[numYears]; 
String[] paragraph = new String[numParagraphs];

JSONArray contentTarget = new JSONArray();
JSONArray wordCountTarget = new JSONArray();
JSONArray numHitsTarget = new JSONArray();
JSONArray pubYearTarget = new JSONArray();
JSONArray docTarget = new JSONArray();
JSONArray strings;

JSONArray pop_hits = new JSONArray();
JSONArray pop_docs = new JSONArray();
JSONArray rock_hits = new JSONArray();
JSONArray rock_docs = new JSONArray();
JSONArray country_hits = new JSONArray();
JSONArray country_docs = new JSONArray();
JSONArray hiphop_hits = new JSONArray();
JSONArray hiphop_docs = new JSONArray();
JSONArray techno_hits = new JSONArray();
JSONArray techno_docs = new JSONArray();
JSONArray electronic_hits = new JSONArray();
JSONArray electronic_docs = new JSONArray();
JSONArray jazz_hits = new JSONArray();
JSONArray jazz_docs = new JSONArray();
JSONArray classical_hits = new JSONArray();
JSONArray classical_docs = new JSONArray();
JSONArray experimental_hits = new JSONArray();
JSONArray experimental_docs = new JSONArray();

StringList[] contentTargetList = new StringList[numWords];
IntList[] wordCountTargetList = new IntList[numWords];
int[] itemList = new int[numWords];

int popLowerLim; 
int popUpperLim;
int rockLowerLim; 
int rockUpperLim;
int countryLowerLim; 
int countryUpperLim;
int hiphopLowerLim; 
int hiphopUpperLim;
int technoLowerLim; 
int technoUpperLim;
int electronicLowerLim; 
int electronicUpperLim;
int jazzLowerLim; 
int jazzUpperLim;
int classicalLowerLim; 
int classicalUpperLim;
int experimentalLowerLim; 
int experimentalUpperLim;

// main draw() variables ---------------------------------------------------------

PFont myFutura12 = createFont("Futura", 12, true);
PFont myFutura16 = createFont("Futura", 16, true);
PFont myFutura18 = createFont("Futura", 18, true);
PFont myFutura30 = createFont("Futura", 30, true);
PFont myFutura40 = createFont("Futura", 40, true);
PFont myFutura50 = createFont("Futura", 50, true);
PFont myFutura60 = createFont("Futura", 60, true);
PFont myFutura100 = createFont("Futura", 100, true);
color[] categoryColor = new color[numWords];
int highLightOpacity = 128; 

float lowRand = -750; 
float hiRand = 750;
PVector[] categoryPosition = new PVector[numObjects];
PVector[] pubDatePosition = new PVector[numObjects];
PVector[] wordCountPosition = new PVector[numObjects];
PVector[] randomPosition = new PVector[numObjects];
PVector[] currentPosition = new PVector[numObjects];

PVector[] velocity = new PVector[numObjects]; 
float G;
float absDistance;
PVector distance; 
PVector distanceA;
PVector distanceB;
PVector normDistanceA;
PVector normDistanceB;
PVector gravVectorA;
PVector gravVectorB;
PVector gravityA;
PVector gravityB;

int target = 0;
int totalMatches = 0;
float animationCounter = 0;
float queryCounter = 0;

DataObject[] agent = new DataObject[numObjects];
ArrayList<DataObject> matchingAgents = new ArrayList<DataObject>();

// sub-section variables ----------------------------------------------------------

String queryString = " ... "; 
int rotationCounter = 0;
int numPoints;
float[][] scrubArray;
int arrayIndex;
float maxValue = 200;

float scale = 100; 
float hitsScale = 1;
int freqRange = 10;
int freqFloor = 100; 

int buttonWidth = 160;
int buttonHeight = 16;
int p5Margin = 20; 
int p5Distance = 20;
int p5LeftMargin; 
int p5TopMargin; 

Range range;

int begin = 0; 
int end = 11; 
float time = 15;
float subZoom = 0;
float x_slide = 0; 

color fontColor = 192; 

boolean gravityFlag = false; 
boolean labelFlag = true;
boolean categoryFlag = false;
boolean wordCountFlag = false;
boolean pubDateFlag = false;
boolean queryFlag = false; 
boolean audioFlag = true;
boolean rotationFlag = true;

boolean category1Flag = true; 
boolean category2Flag = true; 
boolean category3Flag = true; 
boolean category4Flag = true; 
boolean category5Flag = true; 
boolean category6Flag = true; 
boolean category7Flag = true; 
boolean category8Flag = true; 
boolean category9Flag = true;

