void setup() {

  size(1440, 900, OPENGL);

  if (frame != null) {
    frame.setResizable(true);  // resizable window
  }

  cam = new PeasyCam( this, width/2, height/2, 0, 810);
  cam.setMinimumDistance(1);        // lower limit of camera distance to origin
  cam.setMaximumDistance(10000);       // higher limit of camera distance to origin
  cP5 = new ControlP5(this); 
  g3 = (PGraphics3D)g;  
  setupGUI(); 

  minim = new Minim(this);
  out = minim.getLineOut(Minim.MONO, 2048);
  
  for (int i=0; i<numWords; i++) {
    contentTargetList[i] = new StringList();
    wordCountTargetList[i] = new IntList();
  }
  for (int i=0; i<numYears; i++) {
    beginDate[i] = firstBeginDate + i*10000;
    endDate[i] = firstEndDate + i*10000;
    //println(beginDate[i] + "  " + endDate[i]);
  }

//  for (int i=0; i<numWords; i++) {
//    delay(100);
//    for (int j=0; j<numYears; j++) {
//      delay(100);
//      println("\nword: " + words[i] + " \tfrom: " + beginDate[j] + " to: " + endDate[j]);
//      getWords(words[i], beginDate[j], endDate[j], i);
//      hits[j] = numHits;
//      numHitsTarget.setInt(j, hits[j]);
//    }
//  }

//      println("\n");
//      printArray(wordCountTargetList);
//      println("\n");
//      printArray(contentTargetList);
//      println("\n");

//  saveJSONArray(contentTarget, "data/experimental_content.json");
//  saveJSONArray(wordCountTarget, "data/experimental_word_count.json");
//  saveJSONArray(pubYearTarget, "data/experimental_pub_years.json");
//  saveJSONArray(numHitsTarget, "data/experimental_num_hits.json");
//  saveJSONArray(docTarget, "data/experimental_docs.json"); 

loadData();

  distance = new PVector(0, 0, 0); 
  distanceA = new PVector(0, 0, 0);
  distanceB = new PVector(0, 0, 0);
  normDistanceA = new PVector(0, 0, 0);
  normDistanceB = new PVector(0, 0, 0);
  gravVectorA = new PVector(0, 0, 0);
  gravVectorB = new PVector(0, 0, 0);
  gravityA = new PVector(0, 0, 0);
  gravityB = new PVector(0, 0, 0);

  // assign data (category, article length, content) to each agent 
  for (int i=0; i<numObjects; i++) {
    int category = 0;
    int categorySize = 0;
    int wordCount = 1000; 
    int pubDateInt = 0;
    String pubDateSub = "NULL";
    String pubDate = "NULL"; 
    String content = "NULL";
    if (i<popUpperLim) { 
      category = 0; 
      wordCount = pop_docs.getJSONObject(i).getInt("word_count");
      pubDate = pop_docs.getJSONObject(i).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = pop_docs.getJSONObject(i).getString("lead_paragraph");
      categorySize = itemList[0];
    }
    if (i>=rockLowerLim && i<rockUpperLim) { 
      category = 1;
      wordCount = rock_docs.getJSONObject(i-rockLowerLim).getInt("word_count");
      pubDate = rock_docs.getJSONObject(i-rockLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = rock_docs.getJSONObject(i-rockLowerLim).getString("lead_paragraph");
      categorySize = itemList[1];
    }
    if (i>=countryLowerLim && i<countryUpperLim) { 
      category = 2;
      wordCount = country_docs.getJSONObject(i-countryLowerLim).getInt("word_count");
      pubDate = country_docs.getJSONObject(i-countryLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = country_docs.getJSONObject(i-countryLowerLim).getString("lead_paragraph");
      categorySize = itemList[2];
    }
    if (i>=hiphopLowerLim && i<hiphopUpperLim) { 
      category = 3;
      wordCount = hiphop_docs.getJSONObject(i-hiphopLowerLim).getInt("word_count");
      pubDate = hiphop_docs.getJSONObject(i-hiphopLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = hiphop_docs.getJSONObject(i-hiphopLowerLim).getString("lead_paragraph");
      categorySize = itemList[3];
    }
    if (i>=technoLowerLim && i<technoUpperLim) { 
      category = 4;
      wordCount = techno_docs.getJSONObject(i-technoLowerLim).getInt("word_count");
      pubDate = techno_docs.getJSONObject(i-technoLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = techno_docs.getJSONObject(i-technoLowerLim).getString("lead_paragraph");
      categorySize = itemList[4];
    }
    if (i>=electronicLowerLim && i<electronicUpperLim) { 
      category = 5;
      wordCount = electronic_docs.getJSONObject(i-electronicLowerLim).getInt("word_count");
      pubDate = electronic_docs.getJSONObject(i-electronicLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = electronic_docs.getJSONObject(i-electronicLowerLim).getString("lead_paragraph");
      categorySize = itemList[5];
    }
    if (i>=jazzLowerLim && i<jazzUpperLim) { 
      category = 6;
      wordCount = jazz_docs.getJSONObject(i-jazzLowerLim).getInt("word_count");
      pubDate = jazz_docs.getJSONObject(i-jazzLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = jazz_docs.getJSONObject(i-jazzLowerLim).getString("lead_paragraph");
      categorySize = itemList[6];
    }
    if (i>=classicalLowerLim && i<classicalUpperLim) { 
      category = 7;
      wordCount = classical_docs.getJSONObject(i-classicalLowerLim).getInt("word_count");
      pubDate = classical_docs.getJSONObject(i-classicalLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = classical_docs.getJSONObject(i-classicalLowerLim).getString("lead_paragraph");
      categorySize = itemList[7];
    }
    if (i>=experimentalLowerLim) { 
      category = 8;
      wordCount = experimental_docs.getJSONObject(i-experimentalLowerLim).getInt("word_count");
      pubDate = experimental_docs.getJSONObject(i-experimentalLowerLim).getString("pub_date");
      pubDateSub = pubDate.substring(0, 4);  
      pubDateInt = int(pubDateSub);
      content = experimental_docs.getJSONObject(i-experimentalLowerLim).getString("lead_paragraph");
      categorySize = itemList[8];
    }
    //velocity[i] = new PVector(random(-1, 1), random(-1, 1), random(-1, 1));
    velocity[i] = new PVector(0,0,0);
    randomPosition[i] = new PVector(random(lowRand, hiRand), random(1000), random(lowRand, hiRand));
    categoryPosition[i] = new PVector(random(lowRand, hiRand), category*200, random(lowRand, hiRand));
    wordCountPosition[i] = new PVector(random(lowRand, hiRand), wordCount/5, random(lowRand, hiRand));
    pubDatePosition[i] = new PVector(random(lowRand, hiRand), -((pubDateInt-1945)*30)+(2000), random(lowRand, hiRand));
    pubDateSub = pubDate.substring(0, 4);  
    pubDateInt = int(pubDateSub);
    agent[i] = new DataObject(i, category, categorySize, wordCount, pubDateInt, content, randomPosition[i], velocity[i], agent);
    //    println("\n" + agent[i].index + "\t" 
    //      + "category: " + words[agent[i].category] + "\t" 
    //      + "word count: " + agent[i].wordCount + "\t" 
    //      + "publication date: " + agent[i].pubDate + "\n" 
    //      + "content: " + agent[i].content + "\n" 
    //      + "position: " + agent[i].currentPosition + "\n");
  }    

  // setup sub-section -------------------------------------------------------------------
  
  numPoints = pop_hits.size();
  scrubArray = new float[numWords][numPoints]; 
  arrayIndex = 0;
  for (int j=0; j<numPoints; j++) {
    scrubArray[0][j] = pop_hits.getInt(j)/hitsScale;
    scrubArray[1][j] = rock_hits.getInt(j)/hitsScale;
    scrubArray[2][j] = country_hits.getInt(j)/hitsScale;
    scrubArray[3][j] = hiphop_hits.getInt(j)/hitsScale;
    scrubArray[4][j] = techno_hits.getInt(j)/hitsScale;
    scrubArray[5][j] = electronic_hits.getInt(j)/hitsScale;
    scrubArray[6][j] = jazz_hits.getInt(j)/hitsScale;
    scrubArray[7][j] = classical_hits.getInt(j)/hitsScale;
    scrubArray[8][j] = experimental_hits.getInt(j)/hitsScale;
  }
}

