void drawSubSection() {
  while (end<1) { 
    end = 1;
  }
  cam.beginHUD();
  // lock the position in the window
  translate(width*2.0, height*1.6, -2000);
  pushMatrix();
  // zoom
  int zoomFactor = 1;
  translate(x_slide*1000, 0, 0);
  if (labelFlag == true) {
    pushMatrix();
    translate(0, 250, 0);
    textAlign(CENTER, CENTER);
    fill(fontColor);
    textFont(myFutura60);
    text("Total hits per year", 0, 0);
    popMatrix();
  }

  scale(subZoom*zoomFactor);
  //rotate
  rotateX(0.3);
  rotateZ(0);
  if (rotationFlag == true) {
    rotateY(rotationCounter*0.005);
  }
  //compensate for change in position when changing range
  if (rotationFlag == false) {
    translate(-(end+begin)*scale-(end+begin), 250, -numWords*0.5*scale);
  } else {
    translate(-(end+begin)*0.5*scale-(end+begin), 0, -numWords*0.5*scale);
  }
  pushMatrix();
  // year labels
  if (labelFlag == true) {
    translate(begin*scale, 50, (numWords-1)*scale);
    pushMatrix();
    if (rotationFlag == true) {
      rotateY(-rotationCounter*0.005);
    }
    textAlign(CENTER, CENTER); 
    fill(255);
    textFont(myFutura100);
    text(begin+1945, 0, 0);
    popMatrix();
    translate(((end-begin)-1)*scale, 0, 0);
    if (rotationFlag == true) {
      rotateY(-rotationCounter*0.005);
    }
    textAlign(RIGHT, CENTER); 
    text(end+1945, 100, 0);
  }
  popMatrix();
  // draw the graphs
  for (int i=0; i<numWords-1; i++) {
    for (int j=begin; j<end-1; j++) {
      colorMode(HSB);
      // toggle categories on/off
      if (i%numWords==0) {
        if (category1Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==1) {
        if (category2Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==2) {
        if (category3Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==3) {
        if (category4Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==4) {
        if (category5Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==5) {
        if (category6Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==6) {
        if (category7Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } else if (i%numWords==7) {
        if (category8Flag==false) { 
          noStroke();
        } else {
          stroke(128+scrubArray[i][j]*128/maxValue, 192, 192, 192);
        }
      } 
      strokeWeight(2);
      //draw category lines
      line(j*scale, -scrubArray[i][j], i*scale, (j+1)*scale, -scrubArray[i][j+1], i*scale);
      colorMode(RGB);
      stroke(150, 150, 150, 100);
      strokeWeight(1);
      //draw grid 
      line(j*scale, -scrubArray[i][j], i*scale, j*scale, -scrubArray[i+1][j], (i+1)*scale);
    }
    //last grid line
    line((end-1)*scale, -scrubArray[i][end-1], i*scale, (end-1)*scale, -scrubArray[i+1][end-1], (i+1)*scale);
  }
  for (int j=begin; j<end-1; j++) {
    colorMode(HSB);
    if (j%numWords==8) {
      if (category9Flag==false) { 
        noStroke();
      } else {
        stroke(128+scrubArray[numWords-1][j]*128/maxValue, 192, 192, 192);
      }
    }
    //last category line
    line(j*scale, -scrubArray[numWords-1][j], (numWords-1)*scale, (j+1)*scale, -scrubArray[numWords-1][j+1], (numWords-1)*scale);
  }

  // draw the moving curser line and points, if toggled
  colorMode(RGB);
  if (rotationCounter%int(20/time) < 20) {
    while (arrayIndex < begin) {
      arrayIndex+=(begin-arrayIndex);
    }
    for (int i=0; i<numWords-1; i++) {
      stroke(192, 192, 0, 100);
      strokeWeight(5);
      line(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale, arrayIndex*scale, -scrubArray[i+1][arrayIndex], (i+1)*scale);
      stroke(255);
      strokeWeight(7*subZoom); 
      //toggle points
      if (i%numWords==0) {
        if (category1Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=popLowerLim; j<popUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==1) {
        if (category2Flag==false) { 
          noStroke();
        } else { 
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=rockLowerLim; j<rockUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==2) {
        if (category3Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=countryLowerLim; j<countryUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==3) {
        if (category4Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=hiphopLowerLim; j<hiphopUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==4) {
        if (category5Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=technoLowerLim; j<technoUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==5) {
        if (category6Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=electronicLowerLim; j<electronicUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==6) {
        if (category7Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=jazzLowerLim; j<jazzUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==7) {
        if (category8Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
          for (int j=classicalLowerLim; j<classicalUpperLim; j++) {
            if ((arrayIndex+1945) == agent[j].pubDate) {
              agent[j].dateTrigger = highLightOpacity;
            } else {
              agent[j].dateTrigger = 0;
            }
          }
        }
      } else if (i%numWords==8) {
        if (category9Flag==false) { 
          noStroke();
        } else {
          point(arrayIndex*scale, -scrubArray[i][arrayIndex], i*scale);
        }
      }
    }
    if (category9Flag==false) { 
      noStroke();
    } else {
      stroke(255);
      strokeWeight(7*subZoom); 
      point(arrayIndex*scale, scrubArray[numWords-1][arrayIndex] * -1, (numWords-1)*scale);
      for (int j=experimentalLowerLim; j<experimentalUpperLim; j++) {
        if ((arrayIndex+1945) == agent[j].pubDate) {
          agent[j].dateTrigger = highLightOpacity;
        } else {
          agent[j].dateTrigger = 0;
        }
      }
    }
  }
  //trigger notes on counter
  if (rotationCounter%int(20/time) == 0) {
    if (audioFlag == true) {
      if (category1Flag==true) {
        out.playNote(0.000, 0.002, new audioGen(freqFloor+scrubArray[0][arrayIndex+1]*freqRange, random(0.75, 0.9)));
        //println("note triggered");
      }
      if (category2Flag==true) {
        out.playNote(0.005, 0.002, new audioGen(freqFloor+scrubArray[1][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category3Flag==true) {
        out.playNote(0.010, 0.002, new audioGen(freqFloor+scrubArray[2][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category4Flag==true) {
        out.playNote(0.015, 0.002, new audioGen(freqFloor+scrubArray[3][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category5Flag==true) {
        out.playNote(0.020, 0.002, new audioGen(freqFloor+scrubArray[4][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category6Flag==true) {
        out.playNote(0.025, 0.002, new audioGen(freqFloor+scrubArray[5][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category7Flag==true) {
        out.playNote(0.030, 0.002, new audioGen(freqFloor+scrubArray[6][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
      if (category8Flag==true) {
        out.playNote(0.0035, 0.002, new audioGen(freqFloor+scrubArray[7][arrayIndex+1]*freqRange, random(0.75, 0.9)));
      }
    }
    arrayIndex++;
    while (arrayIndex >= end) { 
      arrayIndex-=(end-1);
    }
  }
  popMatrix();
  rotationCounter++;
  cam.endHUD();
  //println(arrayIndex);
}

